def _test_crosses():
    import time
    t = time.time()
    z = [
        tc.atcfid for tc in pac.tc.values()
        if tc.crosses(atl.us_west_coast, landfall=True)      #626
        # if tc.crosses(atl.atl_conus_coast, landfall=True, is_TC=True)        #606
        # if tc.crosses(atl.atl_conus_coast, landfall=True, category=3, is_TC=True)        #606
    ]
    print(len(z), "cyclones")
    print(time.time() - t, "seconds")
    return z

def tests_repr():
    print(atl)
    print(atl[1984])
    print(atl[1984,12])
    print(atl[1984,12,1])

def tests_compare():
    for atcfid in atl.tc:
        if atcfid in atlo.tc:
            if atlo[atcfid].ace != atl[atcfid].ace:
                print("{} - {} - {}".format(
                    atlo[atcfid].ace,
                    atcfid,
                    atln[atcfid].ace
                ))
                for eno, enn in zip(atlo[atcfid].entry, atl[atcfid].entry):
                    if eno.wind != enn.wind:
                        print("{} - {} - {}".format(
                            eno.wind,
                            eno.entrytime,
                            enn.wind
                        ))
                    if eno.status != enn.status:
                        print("{} - {} - {} - {}".format(
                            eno.status,
                            eno.entrytime,
                            enn.entrytime,
                            enn.status
                        ))

if __name__ == "__main__":
    import hurdat2parser_dev as hd2
    atl = hd2.Hurdat2("hurdat2-1851-2023-051124.txt", "current_hurdat2_atl.dat")
    # atl = hd2.Hurdat2("hurdat2-1851-2023-051124.txt")
    # atl = hd2.Hurdat2(basin="atl")

    # atl.climograph("ACE", 10, 1, year1=1967)
    # alo = hd2.Hurdat2("hurdat2-1851-2017-050118.txt")
    # alo = hd2.Hurdat2("hurdat2-1851-2018-120319.txt")
    # alo = hd2.Hurdat2("hurdat2-1851-2019-052520.txt")
    # alo = hd2.Hurdat2("hurdat2-1851-2020-052921.txt")
    # alo = hd2.Hurdat2("hurdat2-1851-2021-100522.txt")
    # alo = hd2.Hurdat2("hurdat2-1851-2022-04042023.txt")
    # atl = hd2.Hurdat2("hurdat2-atl-02052024.txt")

    # alo = hd2.Hurdat2("hurdat2-1851-2022-042723.txt")
    atlo = hd2.Hurdat2("hurdat2-1851-2022-050423.txt")

    # atl = hd2.Hurdat2("hurdat2-1851-2021-041922.txt", "https://ksgwxfan.github.io/unofficial_hurdat2/current_hurdat2_atl.dat",urlcheck=True)
    # paco = hd2.Hurdat2("hurdat2-nepac-1949-2021-042522.txt")
    # paco = hd2.Hurdat2("hurdat2-nepac-1949-2022-04042023.txt")

    # pac = hd2.Hurdat2(basin="pac")
    # pac = hd2.Hurdat2("hurdat2-nepac-1949-2023-042624.txt")
    pac = hd2.Hurdat2("hurdat2-nepac-1949-2023-042624.txt", "current_hurdat2_pac.dat")
    # paco = hd2.Hurdat2("hurdat2-nepac-1949-2022-050423.txt")

    z626 = ['AL011851', 'AL041851', 'AL061851', 'AL011852', 'AL031852', 'AL051852', 'AL011854', 'AL031854', 'AL041854', 'AL051855', 'AL011856', 'AL031856', 'AL051856', 'AL021857', 'AL031858', 'AL051859', 'AL071859', 'AL081859', 'AL011860', 'AL041860', 'AL061860', 'AL051861', 'AL081861', 'AL061863', 'AL091863', 'AL041865', 'AL071865', 'AL011866', 'AL071866', 'AL011867', 'AL071867', 'AL021868', 'AL021869', 'AL051869', 'AL061869', 'AL101869', 'AL091870', 'AL011871', 'AL021871', 'AL031871', 'AL041871', 'AL061871', 'AL071871', 'AL011872', 'AL051872', 'AL011873', 'AL031873', 'AL041873', 'AL051873', 'AL011874', 'AL061874', 'AL031875', 'AL041875', 'AL021876', 'AL051876', 'AL021877', 'AL041877', 'AL071877', 'AL011878', 'AL051878', 'AL081878', 'AL111878', 'AL021879', 'AL031879', 'AL041879', 'AL051879', 'AL061879', 'AL071879', 'AL011880', 'AL041880', 'AL061880', 'AL091880', 'AL111880', 'AL011881', 'AL021881', 'AL051881', 'AL061881', 'AL021882', 'AL031882', 'AL041882', 'AL061882', 'AL031883', 'AL031884', 'AL021885', 'AL031885', 'AL041885', 'AL061885', 'AL081885', 'AL011886', 'AL021886', 'AL031886', 'AL051886', 'AL101886', 'AL031887', 'AL041887', 'AL091887', 'AL131887', 'AL161887', 'AL011888', 'AL021888', 'AL031888', 'AL051888', 'AL061888', 'AL071888', 'AL021889', 'AL061889', 'AL091889', 'AL021890', 'AL011891', 'AL031891', 'AL071891', 'AL081891', 'AL011892', 'AL041892', 'AL091892', 'AL011893', 'AL041893', 'AL061893', 'AL081893', 'AL091893', 'AL101893', 'AL111893', 'AL021894', 'AL041894', 'AL051894', 'AL011895', 'AL041895', 'AL061895', 'AL011896', 'AL021896', 'AL041896', 'AL051896', 'AL021897', 'AL031897', 'AL061897', 'AL011898', 'AL021898', 'AL051898', 'AL061898', 'AL071898', 'AL011899', 'AL021899', 'AL031899', 'AL061899', 'AL091899', 'AL011900', 'AL041900', 'AL061900', 'AL011901', 'AL021901', 'AL031901', 'AL041901', 'AL081901', 'AL101901', 'AL011902', 'AL021902', 'AL041902', 'AL031903', 'AL041903', 'AL021904', 'AL041904', 'AL061904', 'AL031905', 'AL051905', 'AL011906', 'AL021906', 'AL051906', 'AL061906', 'AL081906', 'AL011907', 'AL021907', 'AL031907', 'AL021908', 'AL031908', 'AL041908', 'AL051908', 'AL101908', 'AL021909', 'AL031909', 'AL041909', 'AL081909', 'AL091909', 'AL101909', 'AL011910', 'AL031910', 'AL051910', 'AL021911', 'AL031911', 'AL061911', 'AL011912', 'AL021912', 'AL031912', 'AL041912', 'AL051912', 'AL061912', 'AL011913', 'AL041913', 'AL051913', 'AL011914', 'AL011915', 'AL021915', 'AL041915', 'AL061915', 'AL011916', 'AL021916', 'AL031916', 'AL041916', 'AL061916', 'AL071916', 'AL091916', 'AL121916', 'AL141916', 'AL151916', 'AL041917', 'AL011918', 'AL031918', 'AL011919', 'AL021919', 'AL041919', 'AL021920', 'AL031920', 'AL051920', 'AL011921', 'AL051921', 'AL061921', 'AL051922', 'AL011923', 'AL061923', 'AL071923', 'AL081923', 'AL051924', 'AL081924', 'AL101924', 'AL041925', 'AL011926', 'AL031926', 'AL071926', 'AL051927', 'AL011928', 'AL021928', 'AL041928', 'AL011929', 'AL021929', 'AL021930', 'AL011931', 'AL021931', 'AL021932', 'AL031932', 'AL061932', 'AL081932', 'AL111932', 'AL031933', 'AL051933', 'AL061933', 'AL081933', 'AL111933', 'AL011934', 'AL031934', 'AL061934', 'AL071934', 'AL111934', 'AL031935', 'AL071935', 'AL011936', 'AL031936', 'AL041936', 'AL051936', 'AL091936', 'AL011937', 'AL031937', 'AL071937', 'AL101937', 'AL031938', 'AL061938', 'AL071938', 'AL011939', 'AL021939', 'AL041939', 'AL021940', 'AL031940', 'AL061940', 'AL011941', 'AL021941', 'AL051941', 'AL061941', 'AL021942', 'AL031942', 'AL091942', 'AL011943', 'AL071943', 'AL031944', 'AL061944', 'AL071944', 'AL131944', 'AL011945', 'AL051945', 'AL071945', 'AL091945', 'AL011946', 'AL021946', 'AL061946', 'AL071946', 'AL031947', 'AL041947', 'AL051947', 'AL061947', 'AL071947', 'AL091947', 'AL021948', 'AL051948', 'AL081948', 'AL091948', 'AL021949', 'AL051949', 'AL071949', 'AL111949', 'AL021950', 'AL051950', 'AL111950', 'AL131950', 'AL091951', 'AL011952', 'AL021952', 'AL031952', 'AL011953', 'AL031953', 'AL051953', 'AL081953', 'AL091953', 'AL121953', 'AL051954', 'AL061954', 'AL081954', 'AL141954', 'AL011955', 'AL021955', 'AL031955', 'AL051955', 'AL081955', 'AL011956', 'AL071956', 'AL111956', 'AL011957', 'AL021957', 'AL031957', 'AL051957', 'AL061957', 'AL051958', 'AL011959', 'AL031959', 'AL041959', 'AL051959', 'AL081959', 'AL101959', 'AL111959', 'AL011960', 'AL031960', 'AL051960', 'AL061960', 'AL071960', 'AL031961', 'AL051961', 'AL061961', 'AL011962', 'AL061962', 'AL041963', 'AL101963', 'AL011964', 'AL031964', 'AL051964', 'AL061964', 'AL101964', 'AL111964', 'AL011965', 'AL031965', 'AL051965', 'AL091965', 'AL011966', 'AL121966', 'AL131966', 'AL031967', 'AL141967', 'AL011968', 'AL021968', 'AL031968', 'AL051968', 'AL061968', 'AL131968', 'AL141968', 'AL161968', 'AL091969', 'AL161969', 'AL191969', 'AL231969', 'AL241969', 'AL011970', 'AL021970', 'AL041970', 'AL081970', 'AL131970', 'AL201970', 'AL021971', 'AL031971', 'AL051971', 'AL071971', 'AL091971', 'AL101971', 'AL111971', 'AL131971', 'AL141971', 'AL151971', 'AL171971', 'AL201971', 'AL011972', 'AL021972', 'AL041972', 'AL111972', 'AL131972', 'AL101973', 'AL111973', 'AL131973', 'AL021974', 'AL041974', 'AL081974', 'AL101974', 'AL061975', 'AL131975', 'AL181975', 'AL011976', 'AL071976', 'AL081976', 'AL141976', 'AL161976', 'AL011977', 'AL021977', 'AL061977', 'AL151977', 'AL041978', 'AL081978', 'AL091978', 'AL011979', 'AL041979', 'AL061979', 'AL091979', 'AL111979', 'AL121979', 'AL011980', 'AL021980', 'AL041980', 'AL111980', 'AL171980', 'AL041981', 'AL061981', 'AL071981', 'AL101981', 'AL021982', 'AL051982', 'AL031983', 'AL041983', 'AL061983', 'AL011984', 'AL101984', 'AL151984', 'AL171984', 'AL021985', 'AL041985', 'AL051985', 'AL091985', 'AL101985', 'AL111985', 'AL121985', 'AL131985', 'AL021986', 'AL041986', 'AL051986', 'AL031987', 'AL091987', 'AL141987', 'AL021988', 'AL031988', 'AL071988', 'AL121988', 'AL141988', 'AL021989', 'AL041989', 'AL111989', 'AL141989', 'AL151990', 'AL011991', 'AL031991', 'AL041992', 'AL071992', 'AL021993', 'AL011994', 'AL021994', 'AL031994', 'AL121994', 'AL011995', 'AL041995', 'AL051995', 'AL111995', 'AL171995', 'AL011996', 'AL021996', 'AL061996', 'AL101996', 'AL051997', 'AL021998', 'AL031998', 'AL051998', 'AL061998', 'AL071998', 'AL081998', 'AL131998', 'AL031999', 'AL051999', 'AL081999', 'AL101999', 'AL131999', 'AL092000', 'AL112000', 'AL122000', 'AL012001', 'AL032001', 'AL082001', 'AL022002', 'AL052002', 'AL062002', 'AL092002', 'AL102002', 'AL122002', 'AL132002', 'AL032003', 'AL042003', 'AL072003', 'AL112003', 'AL122003', 'AL132003', 'AL022004', 'AL032004', 'AL062004', 'AL072004', 'AL082004', 'AL092004', 'AL112004', 'AL142004', 'AL012005', 'AL032005', 'AL042005', 'AL122005', 'AL182005', 'AL222005', 'AL252005', 'AL012006', 'AL062006', 'AL022007', 'AL052007', 'AL072007', 'AL092007', 'AL102007', 'AL042008', 'AL052008', 'AL062008', 'AL072008', 'AL082008', 'AL092008', 'AL042009', 'AL112009', 'AL022010', 'AL032010', 'AL052010', 'AL042011', 'AL092011', 'AL132011', 'AL022012', 'AL042012', 'AL092012', 'AL182012', 'AL012013', 'AL012014', 'AL012015', 'AL022015', 'AL022016', 'AL032016', 'AL092016', 'AL112016', 'AL142016', 'AL032017', 'AL062017', 'AL092017', 'AL112017', 'AL162017', 'AL012018', 'AL062018', 'AL072018', 'AL142018', 'AL022019', 'AL112019', 'AL162019', 'AL172019', 'AL022020', 'AL032020', 'AL062020', 'AL082020', 'AL092020', 'AL132020', 'AL192020', 'AL222020', 'AL262020', 'AL282020', 'AL292020', 'AL032021', 'AL042021', 'AL052021', 'AL062021', 'AL082021', 'AL092021', 'AL132021', 'AL142021', 'AL012022', 'AL032022', 'AL092022', 'AL172022', 'AL092023', 'AL102023', 'AL162023']


    # tests_repr()
    # tests_compare()
